var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField } from 'vega-slimmer/core';
import { SubStateObserverSlimmer } from '../../../../../helpers/slimmers/sub-state/sub-state-observer-slimmer';
/**
 * Controller for the table head states.
 */
export class VegaTableHeadStateController extends SubStateObserverSlimmer {
  // eslint-disable-next-line jsdoc/require-jsdoc
  constructor() {
    super({
      parent: 'vega-table',
      subStates: [
        {
          subStateName: 'fixed',
          parentStateName: 'scrollConfig',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (scrollConfig) => {
            this.fixed =
              scrollConfig && scrollConfig.maxHeight && scrollConfig.fixedHeader !== false;
          },
        },
      ],
    });
  }
}
__decorate([
  MapToComponentField()
], VegaTableHeadStateController.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadStateController.prototype, "fixed", void 0);
